// YV12Subtract - expansion of AviSynth's Subtract
// YV12Subtract (C) 2003 Kurosu (kurosu@inforezo.org)
// Subtract (C) AviSynth's team

// See legal notice in Interface.cpp and Readme.txt for more information

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __HYSTERY__
#define __HYSTERY__

#include "avisynth.h"

/*
 * Class for subtracting one clip from another
 */
class HysteresyMask : public GenericVideoFilter
{
private:
	PClip			child2;
	int				Y, U, V;
	bool			isInitialized;
	unsigned char	*used;
	int				*Xarray;
	int				*Yarray;

protected:
	void BuildMask(const unsigned char *RMask, const unsigned char *EMask,
					unsigned char *ResultMask, const int row_size, const int height,
					const int RMPitch, const int EMPitch, const int ResMPitch);
	void ExpandMask(const unsigned char *RMask, const unsigned char *EMask,
					unsigned char *ResultMask, const int row_size, const int height,
					const int RMPitch, const int EMPitch, const int ResMPitch, int x, int y);
public:
	HysteresyMask(PClip _child1, PClip _child2,  
					 int y, int u, int v, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	~HysteresyMask();
};

#endif