// General Convolution : allow to make a convolution in YV12 colorspace
// General Convolution (C) 2004 Manao (manao@melix.net)

// See legal notice in Interface.cpp and Readme.txt for more information

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef __GC__
#define __GC__

#include "avisynth.h"

typedef unsigned int uint;

class YV12Convolution : public GenericVideoFilter {
private:
	int				Y,U,V;
	int				*horvect, *vervect;
	double			*horvectf, *vervectf;
	double			totalf;
	int				total;
	int				horres, verres;

protected:
	void (*GC) (const unsigned char *srcp, unsigned char *derp, const int src_pitch,
				const int der_pitch, const int row_size, 
				const int height, const int *horvect, const int *vervect,
				const double *horvectf, const double *vervectf,
				const int horres, const int verres, const int total, const double totalf);
	bool AnalyseString(const char *string, double **vectf, int **vect, int *halflength, IScriptEnvironment* env, bool *isFloat);

public:
	YV12Convolution(PClip _child, const char * horizontal, const char *vertical,
							int ttl, bool automatic, bool saturate, int y, int u, int v,
							bool usemmx, IScriptEnvironment* env);
	~YV12Convolution();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
	
};

#endif