/*
**                    TIVTC v0.9.9 for AviSynth 2.5.x
**
**   TIVTC includes a field matching filter (TFM) and a decimation
**   filter (TDecimate) which can be used together to achieve an
**   IVTC or for other uses. TIVTC currently supports YV12 and 
**   YUY2 colorspaces.
**   
**   Copyright (C) 2004-2005 Kevin Stone
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "TFM.h"

AVSValue TFM::ConditionalIsCombedTIVTC(int n, IScriptEnvironment* env) 
{
	if (n < 0) n = 0;
	else if (n > nfrms) n = nfrms;
	int np = vi.IsYV12() ? 3 : 1;
	int blockN = -20, xblocks, MICount;
	return checkCombed(child->GetFrame(n, env), n, env, np, 1, blockN, xblocks, MICount);
}

AVSValue __cdecl Create_IsCombedTIVTC(AVSValue args, void* user_data, IScriptEnvironment* env) 
{
	AVSValue cnt = env->GetVar("current_frame");
	if (!cnt.IsInt())
		env->ThrowError("IsCombedTIVTC:  This filter can only be used within ConditionalFilter!");
	int n = cnt.AsInt();
	TFM *f = new TFM(args[0].AsClip(),-1,-1,1,5,"","","","",false,false,false,false,
		15,args[1].AsInt(10),args[2].AsInt(85),args[3].AsBool(true),args[4].AsInt(16),
		args[5].AsInt(16),0,0,"",0,env);
	AVSValue IsCombedTIVTC = f->ConditionalIsCombedTIVTC(n, env);	
	delete f;
	return IsCombedTIVTC;
}