/*
**                    TIVTC v0.9.9 for AviSynth 2.5.x
**
**   TIVTC includes a field matching filter (TFM) and a decimation
**   filter (TDecimate) which can be used together to achieve an
**   IVTC or for other uses. TIVTC currently supports YV12 and 
**   YUY2 colorspaces.
**   
**   Copyright (C) 2004-2005 Kevin Stone
**
**   This program is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <math.h>
#define TFMPP_INCLUDED
#ifndef TFM_INCLUDED
#include "TFM.h"
#endif
#ifdef VERSION
#undef VERSION
#endif
#define VERSION "v0.9.6.5"

class TFMPP : public GenericVideoFilter
{
private:
	const char *ovr;
	int PP, PPS, nfrms, mthresh, mthreshS, setArraySize;
	int *setArray;
	bool display, uC2;
	char buf[270];
	PClip clip2;
	void TFMPP::buildMotionMask(PVideoFrame &prv, PVideoFrame &src, PVideoFrame &nxt, 
		PVideoFrame &mask, int use, int np);
	void TFMPP::buildMotionMaskYV12(PVideoFrame &prv, PVideoFrame &src, 
		PVideoFrame &nxt, PVideoFrame &mask, int use);
	void TFMPP::buildMotionMaskYUY2(PVideoFrame &prv, PVideoFrame &src, 
		PVideoFrame &nxt, PVideoFrame &mask, int use);
	void TFMPP::BlendDeint(PVideoFrame &src, PVideoFrame &mask, PVideoFrame &dst, 
		bool nomask, int np);
	void TFMPP::maskClip2(PVideoFrame &src, PVideoFrame &deint, PVideoFrame &mask, 
		PVideoFrame &dst, int np);
	void TFMPP::putHint(PVideoFrame &dst, int field, unsigned int hint);
	void TFMPP::getHint(PVideoFrame &src, int &field, bool &combed, unsigned int &hint);
	void TFMPP::getSetOvr(int n);
	void TFMPP::copyFrame(PVideoFrame &dst, PVideoFrame &src, IScriptEnvironment *env, int np);
	void TFMPP::denoiseYUY2(PVideoFrame &mask);
	void TFMPP::denoiseYV12(PVideoFrame &mask);
	void TFMPP::linkYUY2(PVideoFrame &mask);
	void TFMPP::linkYV12(PVideoFrame &mask);
	void TFMPP::CubicDeint(PVideoFrame &src, PVideoFrame &mask, PVideoFrame &dst, bool nomask, 
					   int field, int np);
	unsigned char TFMPP::cubicInt(unsigned char p1, unsigned char p2, unsigned char p3, unsigned char p4);
	void TFMPP::writeDisplay(PVideoFrame &dst, int np, int n, int field);
	void TFMPP::elaDeint(PVideoFrame &dst, PVideoFrame &mask, PVideoFrame &src, bool nomask, int field, int np);
	void TFMPP::elaDeintYV12(PVideoFrame &dst, PVideoFrame &mask, PVideoFrame &src, bool nomask, int field);
	void TFMPP::elaDeintYUY2(PVideoFrame &dst, PVideoFrame &mask, PVideoFrame &src, bool nomask, int field);

public:
	PVideoFrame __stdcall TFMPP::GetFrame(int n, IScriptEnvironment* env);
    TFMPP(PClip _child, int _PP, int _mthresh, const char* _ovr, bool _display, PClip _clip2, 
		IScriptEnvironment* env);
	TFMPP::~TFMPP();
};